/*
GUIBEGIN
WINDOW , 27, 67, 115, 201, DOCK|EMBED|CAPTION|SYSMENU, , Help contents
	FONT 8, 400, MS Shell Dlg
	TREE 0, 0, 70, 70, LINES|ROOT|ALWAYS|REALHEIGHT, , Selection, , MyHeadings
DEND
GUIEND
*/

/* This child script simply displays a docking window that contains a
 * a TREE control (which fills the docking window) listing the pages in
 * our "help book".
 *
 * It is assumed that the creator passes one extra arg to CreateObject --
 * the parent window handle.
 */

Create:
	GuiErr = "SYNTAX"
	GuiHeading = 1

	/* Initialize the TREE variables. We'll put the titles of the
	 * pages in MyHeadings. stem, and the respective URLs in MyUrls.
	 * stem.
	 */
	MyHeadings.1 = "File menu"
	MyHeadings.1.1 = "Open"
	MyHeadings.1.2 = "Save"
	MyHeadings.1.3 = "Exit"

	MyUrls.1 = ""	/* No page associated with this */
	MyUrls.1.1 = "FileOpen"
	MyUrls.1.2 = "FileSave"
	MyUrls.1.3 = "FileExit"

	/* Create a docked window, with the caller's window as owner. */
	GuiCreateWindow("NORMAL", ARG(1))

	RETURN

Destroy:
	GuiDestroyWindow()
	RETURN

/* Called by Reginald when the docking window is resized. */
WM_SIZE:
	/* Resize the HTML control so that it fills our window. We do this
	 * by calling GuiSetCtlPlacement, with the same X, Y, Width and Height
	 * as our size event now. But don't do this until the HTML control
	 * is finally created (ie, SIZE events can happen for the window
	 * before its controls are created).
	 */
	IF GuiInfo("HANDLE", "Selection", 2) \== "" THEN
		GuiSetCtlPlacement("Selection", ARG(1), ARG(2), ARG(3), ARG(4))
	RETURN ""

/* Called by Reginald when the Tree's selection changes. */
WM_SELCHANGED_Selection:
	/* Get the selection. */
	GuiGetCtlValue("Selection")

	/* Get the respective URL. */
	Url = VALUE("MyUrls."||Selection)

	/* Is it not blank? */
	IF Url \== "" THEN

		/* Wake up the main script with that URL as the signal */
		GuiWake("its:Help.chm::" || Url || ".htm")

	ELSE
		/* You could blank the page, or just not wake the main script. Depends
		 * what you want the reference window to display when he clicks on
		 * some heading that doesn't have a web page.
		 */
		GuiWake("about:blank")

	RETURN